/*

  yyydefaultprogram - main sceleton
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "memchk.hpp"
#include "yyyexceptions.hpp"
#include "fatal.hpp"
#include "yyyscheduler.hpp"

int main(int argc, char *argv[])
{
  int retcode=1;
  memchk::resetsituation();
  {
    yyyexceptions::except_init();
    try {
      yyyscheduler::scheduler s;
      yyyscheduler::scheduler::gsched = &s;
      myapp t(argc, argv);
      s.run();
      retcode=t.getretcode();
    } catch (yyyexceptions::except_base &x) {
      fatal(x.humandump());
    } catch (const char *const x) {
      fatal(x);
    };
  };
  if (!memchk::everythingzero()) memchk::printstatistics(cout);
  
  return retcode;
};
