# this file is included by the various compile scripts.
# here you can change settings to reflect your system.
# the script will be read by the "bash" shell.

set -e

# the following two lines do that if in emacs you do M-x compile and run
# the scripts, then the PATH setting will not include my ~/.bash_profile paths.
# therefor the script sets its own paths. of course you might have to fix them.
LOCALBIN=/home/erik/localinst
PATH="$PATH":\
/home/erik/libsigc++/bin:\
/home/erik/gtkmm/bin



# choose one of the following settings, or define your own one.

# --- debug, noopt
C="-O0 -g"
L="-g"

# --- debug, profile, noopt
#C="-O0 -g -pg"
#L="-g -pg"

# --- superopt with debug
#C="-O2 -g"
#L="-g"

# --- superopt
#C="-O2"
#L="-s"



# options that shall always be there:
C="$C -Wall -Werror"

# libs - redefine those variables to suit your system!
CSIG="$(sigc-config --cflags)"
LSIG="$(sigc-config --libs)"

CGTK="$(gtkmm-config --cflags)"
LGTK="$(gtkmm-config --libs)"

CQT="-I/usr/lib/qt2/include"
LQT="-L/usr/lib/qt2/lib -lqt"



# change those functions to reflect your needs.

# the c++ compiler.
function CXX
{
    echo "g++ $@"
    g++ "$@"
}

# if you don't have libqt, don't care.
function MOC
{
    echo "moc $@"
    moc "$@"
}

# you need m4 in order to create the source files.
function M4
{
    echo "m4 $1 > $2"
    m4 "$1" > "$2"
}
