/*

  yyysendables - makes it possible to send ints of all sizes through yyybinbuff
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __YYYSENDABLES_HPP
#define __YYYSENDABLES_HPP

#include "yyybinbuff.hpp"

// everything is stored in binary and network byte order

// uint8
void appendtobinbuffer (const uint8 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(uint8 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// int8
void appendtobinbuffer (const int8 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(int8 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// uint16
void appendtobinbuffer (const uint16 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(uint16 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// int16
void appendtobinbuffer (const int16 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(int16 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// uint32
void appendtobinbuffer (const uint32 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(uint32 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// int32
void appendtobinbuffer (const int32 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(int32 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// uint64
void appendtobinbuffer (const uint64 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(uint64 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// int64
void appendtobinbuffer (const int64 a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(int64 &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

// bool
void appendtobinbuffer (const bool a, yyybinbuff::binbuff &b);
const yyybinbuff::binbuff::index readfrombinbuffer(bool &a, const yyybinbuff::binbuff &b, const yyybinbuff::binbuff::index pos);

#endif
