#include "yyyscheduler.hpp"
#include "fatal.hpp"
#include "memchk.hpp"

#include <iostream>
#include <vector>

#include <unistd.h>

using namespace yyyzeit;

void empf(yyyscheduler::scheduler::ionotify &)
{
  cout << "FIRE!\n";
  char c;
  read (0,&c,1);
  cout << "i read " << c << endl;
  if (c=='q') {
    cout << "i terminate the scheduler!\n";
    yyyscheduler::scheduler::gsched->setterminated();
  }else if (c=='w') {
    cout << "i sleep for 5 secs\n";
    sleep(5);
  };
};

yyyscheduler::scheduler::abstimer *a;
zeit oldy;
int secs=0;

void tima(yyyscheduler::scheduler::abstimer &)
{
  cout << "TIMA! " << secs << endl;
  secs++;
  oldy+=seconds(1);
  a->setfiretime(oldy);
};

void oldmain()
{
  yyyscheduler::scheduler s;
  yyyscheduler::scheduler::gsched=&s;

  yyyscheduler::scheduler::ionotify n;
  n.setfilehandle(0,yyyscheduler::scheduler::ionotify::READ);
  n.fire.connect(SigC::slot(empf));

  a=new yyyscheduler::scheduler::abstimer;
  a->fire.connect(SigC::slot(tima));
  oldy=getcurrenttime();
  a->setfiretime(oldy);

  s.run();

  delete a;
};

int main()
{
  memchk::resetsituation();
  {
    try {
      oldmain();
    } catch (const char *const x) {
      fatal(x);
    };
  };
  if (!memchk::everythingzero()) memchk::printstatistics(cout);
  
  return 0;
};
