include(macros.m4)dnl
dnl
dnl specify how many template parameters you want at maximum.
dnl if you want to learn how all this works, set NUMP to 0 or 1 and do m4. then read yyypostman.hpp
define(NUMP,4)dnl
dnl
dnl by the way, you can set your editor to C++ mode for this file.
dnl at least emacs does a very good job.
dnl
/*

  yyypostman - a signal and slot extension over binary streams
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

dnl ignore the next line. the current file IS the source file!
// !!!! THIS FILE IS AUTOMATICALLY GENERATED, DO NOT EDIT   !!!!
// !!!! IF YOU WANT TO LEARN MORE ABOUT HOW ALL THIS WORKS, !!!!
// !!!! SEE THE yyypostman.hpp.m4 SOURCE FILE.              !!!!

#ifndef __YYYPOSTMAN_HPP
#define __YYYPOSTMAN_HPP

#include <map>
#include <sigc++/signal_system.h>

#include "yyytypemagic.hpp"

namespace yyypostman {

class sender_base : public SigC::Object {
};

define([<MK_SENDER_SPECIFIC>],[<dnl
template <class binstream, class msgkind[<>]IFNZ($1,KOMMA )REP($1,class m?-?t,KOMMA )>
class sender_specific$1 : public sender_base {
public:
  sender_specific$1 (binstream &net_, yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind>::addreference>::addconst kind_)
    : s(SigC::slot(*this,&sender_specific$1<binstream, msgkind[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )>::sfunc)),
    net(net_), kind(kind_)
  {};
  void sfunc (REP($1,[<m?-?t m?-?>],KOMMA ))
  {
    appendtobinbuffer(kind, net.sendbuffer);
REP($1,[<dnl
    appendtobinbuffer(m?-?, net.sendbuffer);
>])dnl
    net.send();
  };
  SigC::Slot$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> s;
private:
  binstream &net;
  yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind>::removereference>::addconst kind;
};

>])dnl
REP0(NUMP,[<MK_SENDER_SPECIFIC(?-?)>])dnl

template <class binbuffer>
class receiver_base {
public:
  typedef typename binbuffer::index index;

  virtual ~receiver_base() {};
  virtual const index specificreadfrombinbuffer (const binbuffer &b, const index startpos) =0;
};

define([<MK_RECEIVER_SPECIFIC>],[<dnl
template <class binbuffer[<>]IFNZ($1,KOMMA )REP($1,class m?-?t,KOMMA )>
class receiver_specific$1 : public receiver_base<binbuffer> {
public:
  typedef typename binbuffer::index index;

  const index specificreadfrombinbuffer (const binbuffer &b, const index startpos)
  {
IFNZ($1,[<dnl
    index i, numread = 0;
>])dnl
REP($1,[<dnl
    yyytypemagic::typeconvert<yyytypemagic::typeconvert<m?-?t>::removereference>::removeconst m?-?;
>])dnl
REP($1,[<dnl
    if ((i=readfrombinbuffer(m?-?, b, startpos+numread)) < 0) return i;
    numread+=i;
>])dnl
    s.emit(REP($1,m?-?,KOMMA ,));
    return ifelse($1,0,0,numread);
  };
  SigC::Signal$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> s;
};

>])dnl
REP0(NUMP,[<MK_RECEIVER_SPECIFIC(?-?)>])dnl

template <class msgkind_, class binstream_>
class postman : public SigC::Object {
public:
  typedef yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind_>::removereference>::removeconst noconst_msgkind_noref;
  typedef yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind_>::removereference>::addconst const_msgkind_noref;
  typedef yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind_>::addreference>::removeconst noconst_msgkind_ref;
  typedef yyytypemagic::typeconvert<yyytypemagic::typeconvert<msgkind_>::addreference>::addconst const_msgkind_ref;
  typedef msgkind_ msgkind;
  typedef binstream_ binstream;
  typedef typename binstream::binbuffer binbuffer;

  // --- init / deinit

  postman (binstream *const net_)
    : net(*net_),
      netreceivecon(net.receive.connect(SigC::slot(*this, &postman<msgkind, binstream>::netreceive))),
      insidenetreceive(false)
  {
  };
  // postman cannot be copied!
  postman (const postman &);
  postman & operator= (const postman &);
  ~postman ()
  {
    for (sender_map_type::iterator i=sender_map.begin();i!=sender_map.end();++i) delete i->second;
    for (receiver_map_type::iterator i=receiver_map.begin();i!=receiver_map.end();++i) delete i->second;
  };

  // --- sending into stream

define([<MK_SENDER_STUFF>],[<dnl
  IFNZ($1,[<template <REP($1,class m?-?t,KOMMA )> >])SigC::Slot$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> & sender$1_open (const_msgkind_ref k)
  {
    if (sender_map.find(k)!=sender_map.end()) throw "postman: sender$1_open: already open";
    sender_specific$1 <binstream, msgkind[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> *neu =
      new sender_specific$1 <binstream, msgkind[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> (net,k);
    sender_map[k]=neu;
    return neu->s;
  };

  IFNZ($1,[<template <REP($1,class m?-?t,KOMMA )> >])SigC::Slot$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> & sender$1 (const_msgkind_ref k) const
  {
    sender_map_type::const_iterator i=sender_map.find(k);
    if (i==sender_map.end()) throw "postman: sender$1: not found";
    typedef sender_specific$1 <binstream, msgkind[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> v_type;
    v_type *v = dynamic_cast<v_type*> (i->second);
    if (!v) throw "postman: sender$1: your signaltype does not match the registered one!";
    return v->s;
  };

>])dnl
REP0(NUMP,[<MK_SENDER_STUFF(?-?)>])dnl

  void senderx_close (const_msgkind_ref k)
  {
    sender_map_type::iterator i=sender_map.find(k);
    if (i==sender_map.end()) throw "postman: senderx_close: not open";
    delete i->second;
    sender_map.erase(i);
  };

  // --- receiving out of stream

define([<MK_RECEIVER_STUFF>],[<dnl
  IFNZ($1,[<template <REP($1,class m?-?t,KOMMA )> >])SigC::Signal$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> & receiver$1_open (const_msgkind_ref k)
  {
    if (receiver_map.find(k)!=receiver_map.end()) throw "postman: receiver$1_open: already open";
    receiver_specific$1 <binbuffer[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> *neu =
      new receiver_specific$1 <binbuffer[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )>;
    receiver_map[k]=neu;
    return neu->s;
  };

  IFNZ($1,[<template <REP($1,class m?-?t,KOMMA )> >])SigC::Signal$1<void[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> & receiver$1 (const_msgkind_ref k) const
  {
    receiver_map_type::const_iterator i=receiver_map.find(k);
    if (i==receiver_map.end()) throw "postman: receiver$1: not found";
    typedef receiver_specific$1 <binbuffer[<>]IFNZ($1,KOMMA )REP($1,m?-?t,KOMMA )> v_type;
    v_type *v = dynamic_cast<v_type*> (i->second);
    if (!v) throw "postman: receiver$1: your signaltype does not match the registered one!";
    return v->s;
  };

>])dnl
REP0(NUMP,[<MK_RECEIVER_STUFF(?-?)>])dnl

  void receiverx_close (const_msgkind_ref k)
  {
    receiver_map_type::iterator i=receiver_map.find(k);
    if (i==receiver_map.end()) throw "postman: receiverx_close: not open";
    delete i->second;
    receiver_map.erase(i);
  };

  SigC::Signal1<void, postman & > corruptreceived;

  // --- private part. don't use anything below this line.
private:

  void netreceive(binstream &) // slot
  {
    // we must protect ourselfes because we not erase a message at once, but
    // only if the whole buffer has been worked on.
    // imagine ABC messages in buffer. now first A is emitted.
    // then B, but our evil B does that another message D gets into our buffer, so the
    // buffer is now ABCD, but it also calls netreceive. and this new netreceive
    // will now emit A again, because it has not been deleted.
    // that ugly scenario can only happen with local loop back devices, i suppose.
    if (insidenetreceive) return;
    insidenetreceive=true;

    noconst_msgkind_noref kind;
    typename binbuffer::index curpos=0,n1,n2;

  again:
    if (curpos>262144) { // the value does not matter. (aehm ;) it has impacts on speed)
      // the bigger the faster?
      net.receivebuffer.erase(0,curpos);
      curpos=0;
      // otherwise we get infinite big buffer if endless resending in loopback mode ;)
    };
    n1 = readfrombinbuffer(kind, net.receivebuffer, curpos);
    if (n1 == -2) { disasterreceived(); return; };
    if (n1 >= 0) {
      receiver_map_type::iterator it=receiver_map.find(kind);
      if (it==receiver_map.end()) { disasterreceived(); return; };
      n2 = it->second->specificreadfrombinbuffer(net.receivebuffer, curpos+n1);
      if (n2 == -2) { disasterreceived(); return; };
      if (n2 >= 0) {
	curpos += n1+n2;
	goto again;
      };
    };
    net.receivebuffer.erase(0,curpos);

    insidenetreceive=false;
  };

  // this is called in order to shut down the receive channel due to disaster
  void disasterreceived ()
  {
    netreceivecon.disconnect();
    net.receive.connect(SigC::slot(*this, &postman<msgkind, binstream>::discardreceive));
    discardreceive(net);
    corruptreceived.emit(*this);
  };

  void discardreceive(binstream &) // slot
  {
    net.receivebuffer.erase(0,net.receivebuffer.size());
  };

  typedef map<const_msgkind_noref,sender_base* > sender_map_type;
  sender_map_type sender_map;
  typedef map<const_msgkind_noref,receiver_base<binbuffer>* > receiver_map_type;
  receiver_map_type receiver_map;
  binstream &net;
  SigC::Connection netreceivecon;
  bool insidenetreceive;
};

};

#endif
