#include "bullqtmw.hpp"

#include <qlayout.h>
#include <qhbox.h>
#include <qgrid.h>
#include <qprogressbar.h>
#include <qpushbutton.h>

#include <iostream>

mw::mw(QWidget *parent,const char *name)
  : QWidget(parent,name)
{
  QVBoxLayout *v = new QVBoxLayout (this,10);
  v->setResizeMode(QLayout::Fixed);

  QLabel *topic = new QLabel ("--- BULL for QT ---",this);
  v->addWidget(topic);

  QHBox *con = new QHBox(this);
  con->setSpacing(5);
  new QLabel("Connect to IP", con);
  newconlineedit = new QLineEdit(con);
  connect(newconlineedit,SIGNAL(returnPressed()),this,SLOT(connectto()));
  v->addWidget(con);

  QPushButton *concloserbt = new QPushButton ("Close Connection",this);
  concloserbt->setEnabled(FALSE);
  connect(concloserbt,SIGNAL(clicked()),this,SLOT(concloserbtslot()));
  v->addWidget(concloserbt);

  QGrid *condisp = new QGrid(2,this);
  condisp->setSpacing(5);
  new QLabel("outgoing connection",condisp);
  outconlabel=new QLabel("*** NO CONNECTION ***",condisp);
  new QLabel("incoming connection",condisp);
  inconlabel=new QLabel("*** NO CONNECTION ***", condisp);
  v->addWidget(condisp);

  QHBox *sen = new QHBox(this);
  sen->setSpacing(5);
  new QLabel("send text", sen);
  new QLineEdit(sen);
  v->addWidget(sen);

  QHBox *inctext = new QHBox(this);
  inctext->setSpacing(5);
  new QLabel("Text",inctext);
  inctextlabel = new QLabel("*** NOT SET ***",inctext);
  v->addWidget(inctext);

  QHBox *setv = new QHBox(this);
  setv->setSpacing(5);
  new QPushButton("PLUS",setv);
  new QPushButton("MINUS",setv);
  v->addWidget(setv);

  QHBox *progm = new QHBox(this);
  progm->setSpacing(5);
  new QLabel("valuedisp",progm);
  QProgressBar *progbar = new QProgressBar(progm);
  progbar->setProgress(66);
  v->addWidget(progm);

  QHBox *col = new QHBox(this);
  col->setSpacing(5);
  new QPushButton("Flipcolor",col);
  inccolorlabel = new QLabel("mycolor",col);
  inccolorlabel->setBackgroundColor(red);
  v->addWidget(col);

  QPushButton *quitbt = new QPushButton("Quit",this);
  connect(quitbt,SIGNAL(clicked()),this,SLOT(close()));
  v->addWidget(quitbt);
};

void mw::concloserbtslot()
{
  cout << "concloserbtslot\n";
};

void mw::connectto()
{
  if (!mycon.isnull()) mycon->disconnect();
  outconlabel->setText(QString("connecting to ")+newconlineedit->text());
  myclient.netconnect(ipv4address(newconlineedit->text().latin1()),portnumber(10000))
    .connect(SigC::slot(*this,&clientprocess::resultavailable));
};
